#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './kldotmatrixdisplaywizardbase.ui'
**
** Created: 2011-05-11T16:51:50
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "kldotmatrixdisplaywizardbase.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <kurllabel.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <knuminput.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qlistview.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "kurllabel.h"
#include "knuminput.h"

/*
 *  Constructs a KLDotMatrixDisplayWizardBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
KLDotMatrixDisplayWizardBase::KLDotMatrixDisplayWizardBase( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "KLDotMatrixDisplayWizardBase" );
    setModal( TRUE );
    KLDotMatrixDisplayWizardBaseLayout = new QVBoxLayout( this, 11, 6, "KLDotMatrixDisplayWizardBaseLayout"); 

    cbAddLibrary = new QCheckBox( this, "cbAddLibrary" );
    KLDotMatrixDisplayWizardBaseLayout->addWidget( cbAddLibrary );

    layout6 = new QHBoxLayout( 0, 0, 6, "layout6"); 
    spacer11 = new QSpacerItem( 11, 280, QSizePolicy::Maximum, QSizePolicy::Minimum );
    layout6->addItem( spacer11 );

    layout5 = new QGridLayout( 0, 1, 1, 0, 6, "layout5"); 

    urlHomepage = new KURLLabel( this, "urlHomepage" );

    layout5->addMultiCellWidget( urlHomepage, 0, 0, 0, 1 );

    layout2 = new QHBoxLayout( 0, 0, 6, "layout2"); 

    tlValue = new QLabel( this, "tlValue" );
    tlValue->setEnabled( FALSE );
    layout2->addWidget( tlValue );

    leValue = new QLineEdit( this, "leValue" );
    leValue->setEnabled( FALSE );
    layout2->addWidget( leValue );

    sbValue = new KIntSpinBox( this, "sbValue" );
    sbValue->setEnabled( FALSE );
    layout2->addWidget( sbValue );

    cbValue = new QComboBox( FALSE, this, "cbValue" );
    cbValue->setEnabled( FALSE );
    layout2->addWidget( cbValue );

    layout5->addLayout( layout2, 2, 0 );
    spacer12 = new QSpacerItem( 196, 20, QSizePolicy::Preferred, QSizePolicy::Minimum );
    layout5->addItem( spacer12, 2, 1 );

    lvValues = new QListView( this, "lvValues" );
    lvValues->addColumn( tr2i18n( "Variable" ) );
    lvValues->addColumn( tr2i18n( "Value" ) );
    lvValues->addColumn( tr2i18n( "Description" ) );
    lvValues->setEnabled( FALSE );
    lvValues->setSelectionMode( QListView::Single );

    layout5->addMultiCellWidget( lvValues, 1, 1, 0, 1 );
    layout6->addLayout( layout5 );
    KLDotMatrixDisplayWizardBaseLayout->addLayout( layout6 );

    layout5_2 = new QHBoxLayout( 0, 0, 6, "layout5_2"); 

    pbOK = new QPushButton( this, "pbOK" );
    layout5_2->addWidget( pbOK );
    spacer10 = new QSpacerItem( 362, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout5_2->addItem( spacer10 );

    pbCancel = new QPushButton( this, "pbCancel" );
    layout5_2->addWidget( pbCancel );
    KLDotMatrixDisplayWizardBaseLayout->addLayout( layout5_2 );
    languageChange();
    resize( QSize(568, 410).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( pbOK, SIGNAL( clicked() ), this, SLOT( slotOK() ) );
    connect( pbCancel, SIGNAL( clicked() ), this, SLOT( slotCancel() ) );
    connect( cbAddLibrary, SIGNAL( toggled(bool) ), this, SLOT( slotAddHD44780Lib(bool) ) );
    connect( lvValues, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( slotSelectedValueChanged(QListViewItem*) ) );
    connect( leValue, SIGNAL( textChanged(const QString&) ), this, SLOT( slotChangeValue(const QString&) ) );
    connect( sbValue, SIGNAL( valueChanged(int) ), this, SLOT( slotChangeValue(int) ) );
    connect( cbValue, SIGNAL( activated(const QString&) ), this, SLOT( slotChangeValue(const QString&) ) );

    // tab order
    setTabOrder( cbAddLibrary, urlHomepage );
    setTabOrder( urlHomepage, lvValues );
    setTabOrder( lvValues, leValue );
    setTabOrder( leValue, sbValue );
    setTabOrder( sbValue, cbValue );
    setTabOrder( cbValue, pbCancel );
    setTabOrder( pbCancel, pbOK );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KLDotMatrixDisplayWizardBase::~KLDotMatrixDisplayWizardBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KLDotMatrixDisplayWizardBase::languageChange()
{
    setCaption( tr2i18n( "Dot matrix display wizard" ) );
    cbAddLibrary->setText( tr2i18n( "Add HD&44780 library by Peter Fleury to the project" ) );
    cbAddLibrary->setAccel( QKeySequence( tr2i18n( "Alt+4" ) ) );
    urlHomepage->setText( tr2i18n( "See http://www.jump.to/fleury for details." ) );
    urlHomepage->setProperty( "url", tr2i18n( "http://homepage.hispeed.ch/peterfleury/group__pfleury__lcd.html" ) );
    tlValue->setText( tr2i18n( "XTAL:" ) );
    leValue->setText( tr2i18n( "F_CPU" ) );
    lvValues->header()->setLabel( 0, tr2i18n( "Variable" ) );
    lvValues->header()->setLabel( 1, tr2i18n( "Value" ) );
    lvValues->header()->setLabel( 2, tr2i18n( "Description" ) );
    lvValues->clear();
    QListViewItem * item = new QListViewItem( lvValues, 0 );
    item->setText( 0, tr2i18n( "XTAL" ) );
    item->setText( 1, tr2i18n( "F_CPU" ) );
    item->setText( 2, tr2i18n( "The clock frequency" ) );

    pbOK->setText( tr2i18n( "&OK" ) );
    pbOK->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    pbCancel->setText( tr2i18n( "Ca&ncel" ) );
    pbCancel->setAccel( QKeySequence( tr2i18n( "Alt+N" ) ) );
}

void KLDotMatrixDisplayWizardBase::slotOK()
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotOK(): Not implemented yet" );
}

void KLDotMatrixDisplayWizardBase::slotChangeValue(const QString&)
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotChangeValue(const QString&): Not implemented yet" );
}

void KLDotMatrixDisplayWizardBase::slotChangeValue(int)
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotChangeValue(int): Not implemented yet" );
}

void KLDotMatrixDisplayWizardBase::slotAddHD44780Lib(bool)
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotAddHD44780Lib(bool): Not implemented yet" );
}

void KLDotMatrixDisplayWizardBase::slotCancel()
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotCancel(): Not implemented yet" );
}

void KLDotMatrixDisplayWizardBase::slotSelectedValueChanged(QListViewItem*)
{
    qWarning( "KLDotMatrixDisplayWizardBase::slotSelectedValueChanged(QListViewItem*): Not implemented yet" );
}

#include "kldotmatrixdisplaywizardbase.moc"
